"use strict";

/* exported logger */

var Article = require("./Article");

var logger = require('../../logger');

function Annotation(javaObject) {
  if (javaObject instanceof Annotation) {
    this.setLink(javaObject.getLink());
    this.setId(javaObject.getId());
    if (javaObject.getArticle() !== undefined) {
      this.setArticle(new Article(javaObject.getArticle()));
    }
    this.setType(javaObject.getType());
    this.setResource(javaObject.getResource());
    this.setAnnotatorClassName(javaObject.getAnnotatorClassName());
    this.setDescriptionByType(javaObject.getDescriptionByType());
    this.setDescriptionByTypeRelation(javaObject.getDescriptionByTypeRelation());
  } else {
    this.setLink(javaObject.link);
    this.setId(javaObject.id);
    if (javaObject.article !== undefined && javaObject.article !== null) {
      this.setArticle(new Article(javaObject.article));
    }
    this.setType(javaObject.type);
    this.setResource(javaObject.resource);
    this.setAnnotatorClassName(javaObject.annotatorClassName);
  }
}

Annotation.prototype.setLink = function(link) {
  this._link = link;
};

Annotation.prototype.getLink = function() {
  return this._link;
};

Annotation.prototype.setId = function(id) {
  this._id = id;
};

Annotation.prototype.getId = function() {
  return this._id;
};

Annotation.prototype.setResource = function(resource) {
  if (resource === undefined) {
    throw new Error("resource cannot be undefined");
  }
  this._resource = resource;
};

Annotation.prototype.getResource = function() {
  return this._resource;
};

Annotation.prototype.setType = function(type) {
  if (type === undefined) {
    throw new Error("type cannot be undefined");
  }
  this._type = type;
};

Annotation.prototype.getType = function() {
  return this._type;
};

Annotation.prototype.setArticle = function(article) {
  this._article = article;
};

Annotation.prototype.getArticle = function() {
  return this._article;
};

Annotation.prototype.setAnnotatorClassName = function(annotatorClassName) {
  this._annotatorClassName = annotatorClassName;
};

Annotation.prototype.getAnnotatorClassName = function() {
  return this._annotatorClassName;
};

Annotation.prototype.setDescriptionByType = function(descriptionByType) {
  this._descriptionByType = descriptionByType;
};

Annotation.prototype.getDescriptionByType = function() {
  return this.descriptionByType;
};

Annotation.prototype.setDescriptionByTypeRelation = function(descriptionByTypeRelation) {
  this._descriptionByTypeRelation = descriptionByTypeRelation;
};

Annotation.prototype.getDescriptionByTypeRelation = function() {
  return this.descriptionByTypeRelation;
};

module.exports = Annotation;
