"use strict";

require("../../mocha-config");

var ChooseAnnotatorsDialog = require('../../../../main/js/gui/admin/ChooseAnnotatorsDialog');
var ServerConnector = require('../../ServerConnector-mock');
var logger = require('../../logger');

var chai = require('chai');
var assert = chai.assert;

describe('ChooseAnnotatorsDialog', function () {
  it('init', function () {
    var dialog = new ChooseAnnotatorsDialog({
      element: testDiv,
      customMap: null
    });
    assert.equal(0, logger.getWarnings().length);
    return dialog.init();
  });

  it('createElementTree', function () {
    var dialog = new ChooseAnnotatorsDialog({
      element: testDiv,
      customMap: null
    });
    return ServerConnector.getConfiguration().then(function (configuration) {
      var treeData = dialog.createElementTree(configuration);

      assert.ok(treeData);
      assert.ok(treeData.text);
      assert.ok(treeData.children);
      assert.equal(2, treeData.children.length);
    })
  });

  it('setElementType', function () {
    var dialog = new ChooseAnnotatorsDialog({
      element: testDiv,
      customMap: null
    });
    return ServerConnector.getConfiguration().then(function (configuration) {
      return dialog.setElementType(configuration.getReactionTypes()[0]);
    })
  });

});
